JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
AudioParameterBool Class Reference
juce_audio_processors » utilities

Provides a class of AudioProcessorParameter that can be used as a boolean value. More...

`#include <juce_AudioParameterBool.h>`

Inheritance diagram for AudioParameterBool:

## Public Member Functions
| AudioParameterBool (const ParameterID &parameterID, const String &parameterName, bool defaultValue, const AudioParameterBoolAttributes &attributes={})
| Creates a AudioParameterBool with the specified parameters.
| AudioParameterBool (const ParameterID &parameterID, const String &parameterName, bool defaultValue, const String &parameterLabel, std::function< String(bool value, int maximumStringLength)> stringFromBool=nullptr, std::function< bool(const String &text)> boolFromString=nullptr)
| Creates a AudioParameterBool with the specified parameters.
| ~AudioParameterBool () override
| Destructor.
bool | get () const noexcept
| Returns the parameter's current boolean value.
| operator bool () const noexcept
| Returns the parameter's current boolean value.
AudioParameterBool & | operator= (bool newValue)
| Changes the parameter's current value to a new boolean.
const NormalisableRange< float > & | getNormalisableRange () const override
| Returns the range of values that the parameter can take.
Public Member Functions inherited from RangedAudioParameter
int | getNumSteps () const override
| Returns the number of steps for this parameter based on the normalisable range's interval.
float | convertTo0to1 (float v) const noexcept
| Normalises and snaps a value based on the normalisable range.
float | convertFrom0to1 (float v) const noexcept
| Denormalises and snaps a value based on the normalisable range.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
Public Member Functions inherited from AudioProcessorParameterWithID
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length.
String | getLabel () const override
| Some parameters may be able to return a label string for their units.
Category | getCategory () const override
| Returns the parameter's category.
String | getParameterID () const override
| Returns an ID that is unique to this parameter.
bool | isMetaParameter () const override
| Should return true if this parameter is a "meta" parameter.
bool | isAutomatable () const override
| Returns true if the host can automate this parameter.
bool | isOrientationInverted () const override
| This can be overridden to tell the host that this parameter operates in the reverse direction.
Public Member Functions inherited from HostedAudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
Public Member Functions inherited from AudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
virtual | ~AudioProcessorParameter ()
| Destructor.
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters.
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter.
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter.
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list.
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String.
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in.
int | getVersionHint () const
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes.
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener.
void | sendValueChangedMessageToListeners (float newValue)

## Protected Member Functions
virtual void | valueChanged (bool newValue)
| Override this method if you are interested in receiving callbacks when the parameter value changes.

## Additional Inherited Members
Public Types inherited from AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }
Public Attributes inherited from AudioProcessorParameterWithID
const String | paramID
| Provides access to the parameter's ID string.
const String | name
| Provides access to the parameter's name.
const String | label
| Provides access to the parameter's label.
const Category | category
| Provides access to the parameter's category.

## Detailed Description

Provides a class of AudioProcessorParameter that can be used as a boolean value.

See also
  AudioParameterFloat, AudioParameterInt, AudioParameterChoice

## Constructor & Destructor Documentation

## ◆ AudioParameterBool() [1/2]

AudioParameterBool::AudioParameterBool | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | bool | defaultValue,
|  | const AudioParameterBoolAttributes & | attributes = {} )

Creates a AudioParameterBool with the specified parameters.

Note that the attributes argument is optional and only needs to be supplied if you want to change options from their default values.

Example usage:

auto attributes = AudioParameterBoolAttributes().withStringFromValueFunction ([] (auto x, auto) { return x ? "On" : "Off"; })
.withLabel ("enabled");
auto param = std::make_unique<AudioParameterBool> ("paramID", "Parameter Name", false, attributes);
AudioParameterBoolAttributes
Properties of an AudioParameterBool.
Definition juce_AudioParameterBool.h:36
RangedAudioParameterAttributes::withStringFromValueFunction
auto withStringFromValueFunction(StringFromValue x) const
An optional lambda function that converts a non-normalised value to a string with a maximum length.
Definition juce_RangedAudioParameter.h:55
x
float x
Definition juce_UnityPluginInterface.h:192

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  defaultValue | The default value
  attributes | Optional characteristics

## ◆ AudioParameterBool() [2/2]

AudioParameterBool::AudioParameterBool | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | bool | defaultValue,
|  | const String & | parameterLabel,
|  | std::function< String(bool value, int maximumStringLength)> | stringFromBool = nullptr,
|  | std::function< bool(const String &text)> | boolFromString = nullptr )

Creates a AudioParameterBool with the specified parameters.

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  defaultValue | The default value
  parameterLabel | An optional label for the parameter's value
  stringFromBool | An optional lambda function that converts a bool value to a string with a maximum length. This may be used by hosts to display the parameter's value.
  boolFromString | An optional lambda function that parses a string and converts it into a bool value. Some hosts use this to allow users to type in parameter values.

## ◆ ~AudioParameterBool()

AudioParameterBool::~AudioParameterBool | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ get()

bool AudioParameterBool::get | ( |  | ) | const
| noexcept

Returns the parameter's current boolean value.

## ◆ operator bool()

AudioParameterBool::operator bool | ( |  | ) | const
| noexcept

Returns the parameter's current boolean value.

## ◆ operator=()

AudioParameterBool & AudioParameterBool::operator= | ( | bool | newValue | ) |

Changes the parameter's current value to a new boolean.

## ◆ getNormalisableRange()

const NormalisableRange< float > & AudioParameterBool::getNormalisableRange | ( |  | ) | const
| override virtual

Returns the range of values that the parameter can take.

Implements RangedAudioParameter.

## ◆ valueChanged()

virtual void AudioParameterBool::valueChanged | ( | bool | newValue | ) |
| protected virtual

Override this method if you are interested in receiving callbacks when the parameter value changes.

The documentation for this class was generated from the following file:

- juce_AudioParameterBool.h